/*
  +-------------------------------------------------------------+
  |                                                             |
  |   Get the system's error string for the given error code.   |
  |                                                             |
  +-------------------------------------------------------------+
*/
#include <windows.h>
#include "serror.h"

char *system_error_string( unsigned int errorcode)
{
    const DWORD BUFSZ = 128;
    static char buffer[ BUFSZ];
    DWORD maxwidth = FORMAT_MESSAGE_MAX_WIDTH_MASK & 32;
    DWORD ret = FormatMessage(
        FORMAT_MESSAGE_FROM_SYSTEM | maxwidth,
        NULL,
        (DWORD)errorcode,
        0,  // Language id.
        buffer,
        BUFSZ,
        NULL
    );
    if( ret == 0 ) buffer[0] = '\0';
    return buffer;
}
